package com.example.entity;

import lombok.Getter;
import lombok.ToString;

import java.util.HashMap;
import java.util.Map;

@Getter
@ToString
public class QueueMessage {
    private String messageType;
    private final Map<String, Object> data = new HashMap<>();

    public static QueueMessage create(String messageType) {
        QueueMessage queueMessage = new QueueMessage();
        queueMessage.messageType = messageType;
        return queueMessage;
    }

    public QueueMessage put(String key, Object value) {
        data.put(key, value);
        return this;
    }

    @SuppressWarnings("unchecked")
    public <T> T get(String key) {
        return (T) data.get(key);
    }
}
